(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: HOUS2.PAS                                                      *)
(*  Obsah: kompletni zdrojak ke hre Housenka, prenositelna verze           *)
(*  Autor: Mircosoft                                                       *)
(*  Posledni uprava: 24.12.2014                                            *)
(*  Pro kompilaci: CRT, DOS, GRAPH (pouze standardni jednotky, lze         *)
(*                 prelozit v libovolnem prekladaci pro libovolny OS)      *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program Housenka;
uses crt,dos,graph;
const lhx=40; lhy=50;{levy horni roh zahrady}
      scx=500;{poloha napisu Score}
      maxlistu=60;{pocet objektu v zahrade celkem}
      dc=200;{cekani v kazdem cyklu [ms]}
      ph=10;{polomer clanku housenky}
      barvahousenky=5; {fialova}
      ne=false; ano=true;
      {klavesy:}
      lsipka=75; psipka=77; hsipka=72; dsipka=80;

type cluk=^clanek;
     clanek=record
            x,y:shortint;
            dalsi:cluk;
            end;

var ocas,vybrano:cluk;{housenka je jednosmerna dynamicka fronta, nove prvky
                       se pripisuji na konec a stare se umazavaji od zacatku,
                       proto je ocas prvni}
    xh,yh:shortint;{poloha hlavy}
    zahrada:array[0..13,0..9]of byte;{hodnota policka:
                                      0 - nic
                                      1 - list
                                      2 - bylina
                                      3 - jed
                                      4 - telo housenky}
    i,j,{pomocne, pro for cykly}
    sezranolistu,{po kazdem ctvrtem housenka povyroste}
    pocetlistu,{aktualni pocet objektu na zahrade}
    p,{pro for cykly v menu}
    vp:byte;{cislo vybrane polozky}
    score,rekord:word;
    bylina,{housenka je nadopovana a muze klidne sezrat jed}
    prodlouzit,{byl sezran ctvrty list, viz sezranolistu}
    konecb:boolean;{ano -> program konci}
    smer:(doprava,nahoru,doleva,dolu);{aktualni smer pohybu housenky}
    zacatek:pointer;{na oznaceni zacatku hromady a pozdejsi smazani housenky
                     z pameti}
    f:file of word;{soubor s rekordem}
    t:text;{soubor s nastavenim, viz Readme.txt}
    x1,y1,x2,y2,{pro kresleni housenky}
    xo1,yo1,xo2,yo2:integer;{pro kresleni oci}
    trojuh:array[1..4]of pointtype;{pro fillpoly}
    o:char;{cteni z klavesnice}

{tri procedury pro pohyb strukturou housenky:}
procedure nazacatek;
begin
vybrano:=ocas;
end;

procedure ojednodal;
begin
vybrano:=vybrano^.dalsi;
end;

procedure nakonec;
begin
nazacatek;
while vybrano^.dalsi<>nil do ojednodal;
end;

procedure kreslipole(kx,ky:shortint);{kresli policko, ale ne housenku}
begin
setfillstyle(9,2);
bar(lhx+40*kx,lhy+40*ky,lhx+40*kx+39,lhy+40*ky+39);
case zahrada[kx,ky]of 1:begin{list}
                        with trojuh[1]do begin
                                         x:=lhx+40*kx+18+random(6);
                                         y:=lhy+40*ky+random(6)+1;
                                         end;
                        with trojuh[2]do begin
                                         x:=lhx+40*kx+8+random(6);
                                         y:=lhy+40*ky+25+random(6);
                                         end;
                        with trojuh[3]do begin
                                         x:=lhx+40*kx+28+random(6);
                                         y:=lhy+40*ky+25+random(6);
                                         end;
                        setfillstyle(1,2);setcolor(2);
                        fillpoly(3,trojuh);bar(lhx+40*kx+19,lhy+40*ky+20,lhx+40*kx+21,lhy+40*ky+34);
                        line(trojuh[1].x,trojuh[1].y+3,lhx+40*kx+20,lhy+40*ky+26);
                        end;
                      2:begin{bylina}
                        setfillstyle(1,2);
                        bar(lhx+40*kx+19,lhy+40*ky+10,lhx+40*kx+21,lhy+40*ky+38);
                        setfillstyle(1,9);setcolor(9);
                        fillellipse(lhx+40*kx+20,lhy+40*ky+10,18,9);
                        setfillstyle(1,15);setcolor(7);
                        fillellipse(lhx+40*kx+20,lhy+40*ky+10,5,2);
                        with trojuh[1]do begin
                                         x:=lhx+40*kx+20;
                                         y:=lhy+40*ky+37-random(4);
                                         end;
                        with trojuh[2]do begin
                                         x:=lhx+40*kx+20;
                                         y:=lhy+40*ky+33-random(7);
                                         end;
                        with trojuh[3]do begin
                                         x:=lhx+40*kx+random(10)+1;
                                         y:=lhy+40*ky+19+random(10);
                                         end;
                        setfillstyle(1,2);setcolor(2);
                        fillpoly(3,trojuh);
                        with trojuh[1]do begin
                                         x:=lhx+40*kx+20;
                                         y:=lhy+40*ky+36-random(5);
                                         end;
                        with trojuh[2]do begin
                                         x:=lhx+40*kx+20;
                                         y:=lhy+40*ky+32-random(8);
                                         end;
                        with trojuh[3]do begin
                                         x:=lhx+40*kx+38-random(10);
                                         y:=lhy+40*ky+18+random(10);
                                         end;
                        fillpoly(3,trojuh);
                        end;
                      3:begin{jed}
                        with trojuh[1]do begin
                                         x:=lhx+40*kx+20;
                                         y:=lhy+40*ky+7+random(5);
                                         end;
                        with trojuh[2]do begin
                                         x:=lhx+40*kx+39-random(6);
                                         y:=lhy+40*ky+33-random(3);
                                         end;
                        with trojuh[3]do begin
                                         x:=lhx+40*kx+19+random(2);
                                         y:=lhy+40*ky+39-random(4);
                                         end;
                        with trojuh[4]do begin
                                         x:=lhx+40*kx+random(6)+1;
                                         y:=lhy+40*ky+33-random(3);
                                         end;
                        setfillstyle(1,15);setcolor(10);
                        fillpoly(4,trojuh);
                        for i:=1 to 90 do putpixel(lhx+40*kx+7+random(28),lhy+40*ky+23+random(14),10);
                        for i:=1 to 30 do putpixel(lhx+40*kx+16+random(10),lhy+40*ky+15+random(8),10);
                        for i:=1 to 33 do putpixel(lhx+40*kx+random(39)+1,lhy+40*ky+random(39)+1,12);
                        end;
                      end;
end;{kreslipole}

procedure novylist;{vytvori nahodne novy list/bylinu/jed na nahodne vybranem policku}
var lx,ly,co,p:byte;
begin
lx:=random(14); ly:=random(10);
p:=random(20)+1;
if p=5 then co:=2
       else if p=8 then co:=3
                   else co:=1;
if(zahrada[lx,ly]=0)and(pocetlistu<maxlistu)and(random(3)>0)then begin
                                                                 zahrada[lx,ly]:=co;
                                                                 inc(pocetlistu);
                                                                 kreslipole(lx,ly);
                                                                 end;
end;{novylist}

procedure startgrafiky;
var gd,gm:integer;
Begin
gd:=9; gm:=2; {kdyby tohle nefungovalo, tak detectgraph(gd,gm), ale program pocita s rezimem 640x480x16}
initgraph(gd,gm,'');
if graphresult<>0 then begin
                       writeln('Nepovedlo se spustit graficky rezim.');
                       halt;
                       end;
End;{startgrafiky}

procedure stintext(x,y:integer; bt,bp:byte; delta:shortint; textik:string);
{na souradnicich x,y vypise barvou bt textik se stinem v barve bp posunutym o delta pixelu sikmo doprava dolu}
Begin
setcolor(bp);
outtextxy(x+delta,y+delta,textik);{stin}
setcolor(bt);
outtextxy(x,y,textik);{text}
End;{stintext}

procedure napis(x,y:integer; bt,bp:byte; hlaska:string);
{na souradnicich x,y vypise barvou bt danou hlasku a podbarvi ji obdelnikem v barve bp}
Begin
setcolor(bt); setfillstyle(1,bp);
bar(x-2,y-1,x+textwidth(hlaska),y+textheight(hlaska));
outtextxy(x,y,hlaska);
End;{napis}

function nastr(cislo:word):string; {prevod cisla na text}
var vysledek:string[5];
Begin
str(cislo,vysledek);
nastr:=vysledek;
End;{nastr}

BEGIN
startgrafiky;
assign(f,'HOUSENKA.REK');
 repeat{menu}
 cleardevice;
 setfillstyle(9,2);bar(0,0,640,480);
 settextstyle(0,0,7);
 stintext(90,100,barvahousenky,4,5,'Housenka');
 settextstyle(0,0,2);
 stintext(82,180,7,0,2,'******* Verze pro PC *******');
 p:=0; vp:=5;
  repeat
  setfillstyle(9,2); bar(200,230,390,400);
  setfillstyle(9,10); bar(200,230+30*p,390,230+30*p+30);
  stintext(250,240,12,4,2,'Start!');
  stintext(250,270,12,4,2,'rekord');
  stintext(250,300,12,4,2,'o hre');
  stintext(250,330,12,4,2,'konec');
  while keypressed do o:=readkey; {reset klavesnice}
  o:=readkey;
  if o=#13 then vp:=p else
  if o=#0 then case ord(readkey) of hsipka:if p>0 then dec(p) else p:=3;
                                    dsipka:if p<3 then inc(p) else p:=0;
                                    end;
  until vp<>5;
 if vp=3 then break;{konec}
 if vp=0 then
 begin{hra}
 score:=0; bylina:=ne; sezranolistu:=0;prodlouzit:=ano; smer:=nahoru;
 pocetlistu:=0; xh:=5; yh:=5; zahrada[5,5]:=4;
 mark(zacatek);{vytvoreni housenky:}
 new(ocas); with ocas^ do begin x:=xh; y:=yh; dalsi:=nil; end; vybrano:=ocas;
 for i:=0 to 13 do for j:=0 to 9 do zahrada[i,j]:=0;{nulovani zahrady}
 cleardevice;{kresleni:}
 setfillstyle(8,7);bar(lhx-15,lhy-15,lhx+15+14*40,lhy+15+10*40);{plot}
 setfillstyle(9,2);bar(lhx,lhy,lhx+14*40,lhy+10*40);{travnik}
 setcolor(7);outtextxy(scx-95,10,'Score:');
 repeat novylist until pocetlistu=maxlistu;
  repeat{cyklus}
  delay(dc);
  setfillstyle(1,barvahousenky);setcolor(barvahousenky);fillellipse(lhx+40*xh+20,lhy+40*yh+20,ph,ph);
  {tim se smazou oci v minule poloze hlavy}
  if keypressed then begin
                     o:=readkey;
                     if o=#0 then begin
                                  o:=readkey;
                                  case ord(o) of lsipka:smer:=doleva;
                                                 psipka:smer:=doprava;
                                                 hsipka:smer:=nahoru;
                                                 dsipka:smer:=dolu;
                                                 end;
                                  end
                             else if upcase(o)='P'then begin
                                                       setcolor(15);
                                                       outtextxy(270,464,'Pauza');
                                                       repeat until keypressed;
                                                       setcolor(0);
                                                       outtextxy(270,464,'Pauza');
                                                       end;
                     end;
  {zkraceni}
  if prodlouzit then prodlouzit:=ne
                else begin
                     nazacatek;
                     zahrada[ocas^.x,ocas^.y]:=0;
                     kreslipole(ocas^.x,ocas^.y);
                     ojednodal;
                     dispose(ocas);
                     ocas:=vybrano;
                     end;
  {/zkraceni}
  case smer of doprava:inc(xh);{nova poloha hlavy}
               nahoru:dec(yh);
               doleva:dec(xh);
               dolu:inc(yh);
               end;
  if(xh>13)or(xh<0)or(yh<0)or(yh>9)then begin{narazila do plotu}
                                        stintext(100,200,7,0,2,'Hlavou ani plot neprorazis.');
                                        delay(300);
                                        break;
                                        end;
  case zahrada[xh,yh]of 1:begin{snezen list}
                          inc(score);inc(sezranolistu);bylina:=ne;
                          dec(pocetlistu);
                          napis(scx,10,7,0,nastr(score));
                          if sezranolistu=4 then begin
                                                 sezranolistu:=0;
                                                 prodlouzit:=ano;
                                                 end;
                          end;
                        2:begin{snezena bylina}
                          inc(score);bylina:=ano;
                          dec(pocetlistu);
                          napis(scx,10,7,0,nastr(score));
                          end;
                        3:begin{snezen jed}
                          dec(pocetlistu);
                          if bylina then begin
                                         bylina:=ne;inc(score);
                                         napis(scx,10,7,0,nastr(score));
                                         end
                                    else begin
                                         delay(200);
                                         setpalette(barvahousenky,2);{zezelenani}
                                         delay(300);
                                         stintext(100,200,10,0,2,'Bleee... chcip.');
                                         break;
                                         end;
                          end;
                        4:begin{narazila sama do sebe}
                          stintext(100,200,12,0,2,'Chramst... Auuu!');
                          delay(300);
                          break;
                          end;
                        end;
  zahrada[xh,yh]:=4;
  setfillstyle(9,2);bar(lhx+40*xh,lhy+40*yh,lhx+40*xh+39,lhy+40*yh+39);
  {prodlouzeni}
  nakonec;
  {kresleni housenky}
  with vybrano^ do
  case smer of doprava:begin
                       x1:=lhx+40*x+20;
                       y1:=lhy+40*y+10;
                       x2:=lhx+40*xh+20;
                       y2:=lhy+40*yh+30;
                       xo1:=lhx+40*xh+25;
                       yo1:=lhy+40*yh+14;
                       xo2:=xo1;
                       yo2:=lhy+40*yh+26;
                       end;
               nahoru:begin
                      x1:=lhx+40*xh+10;
                      y1:=lhy+40*yh+20;
                      x2:=lhx+40*x+30;
                      y2:=lhy+40*y+20;
                      xo1:=lhx+40*xh+14;
                      yo1:=lhy+40*yh+15;
                      xo2:=lhx+40*xh+26;
                      yo2:=yo1;
                      end;
               doleva:begin
                      x1:=lhx+40*xh+20;
                      y1:=lhy+40*yh+10;
                      x2:=lhx+40*x+20;
                      y2:=lhy+40*y+30;
                      xo1:=lhx+40*xh+15;
                      yo1:=lhy+40*yh+14;
                      xo2:=xo1;
                      yo2:=lhy+40*yh+26;
                      end;
               dolu:begin
                    x1:=lhx+40*x+10;
                    y1:=lhy+40*y+20;
                    x2:=lhx+40*xh+30;
                    y2:=lhy+40*yh+20;
                    xo1:=lhx+40*xh+14;
                    yo1:=lhy+40*yh+25;
                    xo2:=lhx+40*xh+26;
                    yo2:=yo1;
                    end;
               end;
  setfillstyle(1,barvahousenky);setcolor(barvahousenky);
  bar(x1,y1,x2,y2);fillellipse(lhx+40*xh+20,lhy+40*yh+20,ph,ph);
  if bylina then begin setfillstyle(1,12);setcolor(4);end{nadopovana housenka ma krvi podlite oci}
            else begin setfillstyle(1,0);setcolor(8);end;{normalne jsou oci cerne}
  fillellipse(xo1,yo1,2,2);fillellipse(xo2,yo2,2,2);
  {/kresleni}
  new(vybrano^.dalsi); ojednodal;
  with vybrano^ do begin
                   x:=xh; y:=yh; dalsi:=nil;
                   end;
  {/prodlouzeni}
  novylist;
  until o=#27;{konec hlavniho cyklu}
 reset(f);{nacteni rekordu}
 if ioresult=0 then begin read(f,rekord);close(f);end else rekord:=0;
 if score>rekord then begin
                      setfillstyle(1,14);bar(200,100,420,300);
                      setfillstyle(1,6);bar(210,110,410,290);
                      stintext(255,130,14,15,-1,'Rekord!');
                      settextstyle(0,0,6);stintext(250,210,14,15,-2,nastr(score));
                      rewrite(f);write(f,score);close(f);
                      end;
 while keypressed do o:=readkey;
 repeat until keypressed;
 setpalette(barvahousenky,barvahousenky); {vraceni barvy pro pripad, ze by zrovna byla zmenena}
 release(zacatek);{vymazani housenky z pameti}
 end{if vp=0}
 else if vp=1 then
 begin{zobrazeni rekordu}
 setfillstyle(1,14);bar(155,100,465,300);
 setfillstyle(1,6);bar(165,110,455,290);
 reset(f);
 if ioresult=0 then begin read(f,rekord);close(f);end else rekord:=0;
 settextstyle(0,0,6);stintext(245,150,14,15,-2,nastr(rekord));
 settextstyle(0,0,2);stintext(175,240,3,11,-1,'Je na tobe, abys');
                     stintext(169,262,3,11,-1,'s tim neco udelal!');
 while keypressed do o:=readkey;
 repeat o:=readkey until not keypressed;
 end
 else if vp=2 then{legenda ;-)}
 begin
 setfillstyle(1,0);bar(20,20,619,459);
 setcolor(2);
 outtextxy(30,40, 'Byla jednou jedna zahradka a v ni zi-');
 outtextxy(30,65, 'la mala housenka. Mela stale hlad, a');
 outtextxy(30,90 ,'tak jedla a jedla.Behala po zahradce');
 outtextxy(30,115,'sem a tam, nikde se nezastavovala a ');
 outtextxy(30,140,'hledala jedle listy. Ven ze zahradky');
 outtextxy(30,165,'sice nemohla, ale i tak mela potravy');
 outtextxy(30,190,'dost. Jenze na zahradce nebyla sama.');
 outtextxy(30,215,'Bydlel tu take zahradnik,ktery nemel');
 outtextxy(30,240,'housenku rad. Proto ji mezi stavnate');
 outtextxy(30,265,'listy sypal hromadky jedu. Ale hou- ');
 outtextxy(30,290,'senka byla chytra.Vedela,ze kdyz sni');
 outtextxy(30,315,'lecivou bylinku a nezaji ji zadnym  ');
 outtextxy(30,340,'listem, muze bez obav snist jednu   ');
 outtextxy(30,365,'hromadku jedu a nic se ji nestane.  ');
 outtextxy(30,390,' A tak housenka rostla a rostla, az ');
 outtextxy(30,415,'ji zahradka zacala byt mala...  ');
 repeat o:=readkey until not keypressed;
 end;
until false;{stejne se to ukoncuje pres break}
closegraph;
END.
{a to je vse, pratele...}