(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: KLAVESY.PAS                                                    *)
(*  Obsah: kody klaves, procedury pro cteni z klavesnice a jeji nastaveni  *)
(*  Autor: Mircosoft (vetsinou)                                            *)
(*         SWAG team: Keypressed a Readkey                                 *)
(*         Istok Atilla: Tokeybuf                                          *)
(*  Posledni uprava: 2.7.2005                                              *)
(*  Pro kompilaci: (DOS)                                                   *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
unit klavesy;
interface
const
{*****************************************************************************
kody nekterych klaves (Readkey je vraci jako #0 a pak #tohle):}
F1=59;     shiftF1=84;     ctrlF1=94;      altF1=104;
F2=60;     shiftF2=85;     ctrlF2=95;      altF2=105;
F3=61;     shiftF3=86;     ctrlF3=96;      altF3=106;
F4=62;     shiftF4=87;     ctrlF4=97;      altF4=107;
F5=63;     shiftF5=88;     ctrlF5=98;      altF5=108;
F6=64;     shiftF6=89;     ctrlF6=99;      altF6=109;
F7=65;     shiftF7=90;     ctrlF7=100;     altF7=110;
F8=66;     shiftF8=91;     ctrlF8=101;     altF8=111;
F9=67;     shiftF9=92;     ctrlF9=102;     altF9=112;
F10=68;    shiftF10=93;    ctrlF10=103;    altF10=113;
F11=133;   shiftF11=135;   ctrlF11=137;    altF11=139;
F12=134;   shiftF12=136;   ctrlF12=138;    altF12=140;
lsipka=75; {75}            ctrllsipka=115; altlsipka=155;
psipka=77; {77}            ctrlpsipka=116; altpsipka=157;
hsipka=72; shiftHsipka=72; ctrlhsipka=141; althsipka=152;
dsipka=80; shiftDsipka=80; ctrldsipka=145; altdsipka=160;
ins=82;    {82}            ctrlins=146;    altins=162;
del=83;    {83}            ctrldel=147;    altdel=163;
home=71;   {71}            ctrlhome=119;   althome=151;
endk=79;   {79}            ctrlend=117;    altend=159;
pgup=73;   {73}            ctrlpgup=132;   altpgup=153;
pgdn=81;   {81}            ctrlpgdn=118;   altpgdn=161;
{F11, F12, Alt+sipky a nektere dalsi kombinace funguji jen s jednotkou EnhKbd}

{****************************************************************************}
{kody klaves, jak je vraci funkce xReadkey:}
xF1=315;  xShiftF1=340;  xCtrlF1=350;    xAltF1=360;
xF2=316;  xShiftF2=341;  xCtrlF2=351;    xAltF2=361;
xF3=317;  xShiftF3=342;  xCtrlF3=352;    xAltF3=362;
xF4=318;  xShiftF4=343;  xCtrlF4=353;    xAltF4=363;
xF5=319;  xShiftF5=344;  xCtrlF5=354;    xAltF5=364;
xF6=320;  xShiftF6=345;  xCtrlF6=355;    xAltF6=365;
xF7=321;  xShiftF7=346;  xCtrlF7=356;    xAltF7=366;
xF8=322;  xShiftF8=347;  xCtrlF8=357;    xAltF8=367;
xF9=323;  xShiftF9=348;  xCtrlF9=358;    xAltF9=368;
xF10=324; xShiftF10=349; xCtrlF10=359;   xAltF10=369;
xF11=484; xShiftF11=251; xCtrlF11=393; xAltF11=395;
xF12=352; xShiftF12=80;  xCtrlF12=370;   xAltF12=396;
xLSipka=331; xShiftLSipka=52; xCtrlLSipka=371;  xAltLsipka=411;
xPSipka=333; xShiftPSipka=54; xCtrlPSipka=372;  xAltPSipka=413;
xHSipka=328; xShiftHSipka=56; xCtrlHSipka=397;  xAltHSipka=408;
xDSipka=336; xShiftDSipka=50; xCtrlDSipka=401;  xAltDSipka=416;
xIns=338;
xDel=339;
xHome=327;
xEndk=335;
xPgUp=329;
xPgDn=337;
{pismena a cislice jsou jejich bezna ordinalni cisla, akorat ve formatu word.
Nektere kombinace klaves opet funguji jen s EnhKbd.}

{*****************************************************************************
Po nainstalovani specialniho preruseni se klavesy ctou z pole Pressed[...].
Jako indexy tohoto pole doporucuji pouzit nasledujici konstanty:}
pEsc=1;      pScrollLock=70{*};pPomlcka=12;   pOk=24;
pF1=59;      pBreak=29{**};    pRovnitko=13;  pPk=25;
pF2=60;      pVlnovka=41;      pBackSlash=43; pLZavorka=26;{ty hranate vedle P}
pF3=61;      p1k=2;            pBackspace=14; pPZavorka=27;
pF4=62;      p2k=3;            pTab=15;       pEnter=28;{oba}
pF5=63;      p3k=4;            pQk=16;        pCapsLock=58{*};
pF6=64;      p4k=5;            pWk=17;        pAk=30;
pF7=65;      p5k=6;            pEk=18;        pSk=31;
pF8=66;      p6k=7;            pRk=19;        pDk=32;
pF9=67;      p7k=8;            pTk=20;        pFk=33;
pF10=68;     p8k=9;            pYk=21;        pGk=34;
pF11=87;     p9k=10;           pUk=22;        pHk=35;
pF12=88;     p0k=11;           pIk=23;        pJk=36;
pKk=37;        pCarka=51;     pPgDn=81;
pLk=38;        pTecka=52;     pLSipka=75;
pStrednik=39;  pLomitko=53{+};pPSipka=77;
pApostrof=40;  pPShift=54;    pHSipka=72;
pLShift=42;    pCtrl=29;      pDSipka=80;
pZk=44;        pAlt=56;       pNumLock=69{*};
pXk=45;        pMezernik=57;  pHvezdicka=55;{ \                      }
pCk=46;        pIns=82;       pMinus=74;    {  \ numericka klavesnice}
pVk=47;        pDel=83;       pPlus=78;     {  /                     }
pBk=48;        pHome=71;      pPad5=76;     { /                      }
pNk=49;        pEnd=79;       pPrintScreen=55;{++}
pMk=50;        pPgUp=73;
{Pokud ctete primo Port[$60], plati tyto poznamky:
 *: Locky vraci nejdriv kod 250 a po chvilce drzeni toto cislo.
 **: Break zpusobuje, ze port vraci tuto hodnotu az do zmacknuti dalsiho
     tlacitka (aspon doufam).
 +: Tento kod ma lomitko na numericke klavesnici i to vedle praveho shiftu.
 ++: Printscreen v textovem rezimu pod Windows zpusobuje Modrou Smrt (BSOD)!
     Pouzivat jen v DOSu nebo v grafice !!!
 Numericka klavesnice vraci stejne kody, jako kdyby byl vypnuty NumLock a jeho
 zapnuti se nijak neprojevi. Tj. 7 = home, 8 = hSipka, 0 = Ins, . = Del apod.
 Kody vsech klaves jsou porad stejne, nezalezi na tom, jestli k nim drzite
 shift, alt nebo ctrl nebo na stavu ~locku.}

var Pressed:array[0..127] of boolean;
{Pomocne pole, do nejz zapisuje procedura MojeInt9. Za index se daji dosadit
vyse uvedene konstanty (ty co zacinaji na P). Pozor, ze tohle pole znamena
jediny zpusob, jak cist klavesy, kdyz je nainstalovane to specialni preruseni.}

function KeyPressed:boolean;
function ReadKey:char;
{uplne stejne jako standardni, jenom ted nemusim pouzivat CRT}
function xReadKey:word;
{pro normalni klavesy funguje jako Readkey (vraci ordinalni cislo stisknute
klavesy), u specialnich (ty, co vraceji nejdriv #0 a az pak nejake cislo)
vrati to druhe cislo zvetsene o 256.
Kody klaves jsou vypsany na zacatku jednotky (ty, co zacinaji na X).}
procedure kCekej;
{cekani na stisk klavesy}
procedure kResetuj;
{vyprazdneni bufferu klavesnice}
function LShiftPressed:boolean;{stisknut levy shift}
function PShiftPressed:boolean;{stisknut pravy shift}
function ShiftPressed:boolean;{stisknut libovolny shift}
function LCtrlPressed:boolean;{stisknut levy control}
function PCtrlPressed:boolean;{stisknut pravy control}
function CtrlPressed:boolean;{stisknut libovolny control}
function LAltPressed:boolean;{stisknut levy alt}
function PAltPressed:boolean;{stisknut pravy alt}
function AltPressed:boolean;{stisknut libovolny alt}
function CapsLockPressed:boolean;{stisknut caps lock}
function NumLockPressed:boolean;{stisknut num lock}
function ScrollLockPressed:boolean;{stisknut scroll lock}
function CapsLock:boolean;{caps lock zapnut}
function NumLock:boolean;{num lock zapnut}
function ScrollLock:boolean;{scroll lock zapnut}
{tyto funkce vraceji true, pokud je splnena prislusna podminka}
procedure SetCapsLock(jak:boolean);
procedure SetNumLock(jak:boolean);
procedure SetScrollLock(jak:boolean);
{tyto procedury zapinaji nebo vypinaji prislusne locky (true=zap., false=vyp.)}
procedure ToKeyBuf(s:string);
{zapise retezec s do bufferu klavesnice, jako kdyby tam byl napsan primo
z klavesnice. Max. 15 znaku - vic se do nej nevejde a klavesnice by zacala
piskat.}
procedure RychlostKlavesnice(zpozdeni,rychlost:byte);
{nastavi rychlost opakovani stisknute klavesy a zpozdeni po prvnim stisku.
rychlost:
 0 - 30  zn/s
 8 - 15  zn/s
16 - 7.5 zn/s
24 - 3.7 zn/s
31 - 2   zn/s
zpozdeni:
0 - 250 ms
1 - 500 ms
2 - 750 ms
3 - 1000 ms
Za 100% funkcnost nerucim.}
procedure InitKlav;
{nainstaluje nove preruseni pro obsluhu klavesnice, takze pujde cist vic
klaves najednou, ale prestane fungovat Keypressed, Readkey a podobne veci.
Klavesy ctete z pole Pressed, napr.: if pressed[pBackspace] then ...}
procedure VratKlav;
{obnovi puvodni funkci klavesnice - pokud jste pouzili InitKlav, je nutne
tohle na konci programu pouzit, jinak by se mohlo stat neco oskliveho
(treba ze by klavesnice prestala reagovat)}
function KlavesyInstalovany:boolean;
{aby se dalo z programu zjistit, jak s klavesnici zachazet. A kvuli
blbuvzdornosti nechci dat promennou Instalovano jako verejnou.}

implementation
uses dos;{pro getintvec a setintvec}

const instalovano:boolean=false;{jestli je nainstalovane nove preruseni klavesnice}

var PuvodniInt9:pointer;{pro ulozeni puvodniho preruseni klavesnice}

Function Keypressed:Boolean; assembler; {by SWAG team}
Asm
mov AX,0B00h
int 21h
{funkce vraci hodnotu z AX, kdyz je nenulova, je to true}
End;{keypressed}

function ReadKey:char; assembler; {by SWAG team}
Asm
mov AX,0700h
int 21h
{funkce vraci hodnotu z AX (AL)}
End;{readkey}

function xReadKey:word; assembler;
Asm
mov AX,0700h {cislo sluzby pro cteni klaves}
int $21      {precteni klavesy - normalni Readkey}
or AL,AL      {neco udelame s AL, ve kterem se vratil ten znak (tak, abychom ho nezmenili), tim se nastavi ZF}
jnz @vratznak {takze kdyz to AL neni 0, skocime dal >> }
 int $21        {jestli jsme jeste tady, tak v AL byla 0, takze precteme dalsi znak (v AX porad jeste je 07h)}
 xor AH,AH      {vynulujeme AH, protoze v nem je jeste porad cislo sluzby pro int $21}
 add AX,256     {k prectenemu znaku pricteme 256, aby bylo poznat, ze to byla specialni klavesa...}
 jmp @konec     {...a mame hotovo.}
@vratznak:
 xor AH,AH     { >> vynulujeme AH, precteny znak zustane v AL a je vymalovano.}
@konec:
{vrati se obsah AX, jako u kazde funkce}
End;{xreadkey}

procedure kcekej;
Begin
repeat until keypressed;
End;{kcekej}

procedure kresetuj; assembler;
Asm             {stejneho efektu se da dosahnout prikazem}
mov AX,0C06h    {while keypressed do znak:=readkey; ale  }
mov DL,$FF      {takhle je to o neco cistsi (a rychlejsi)}
int $21
End;{kresetuj}

var sb:word absolute 0:$0417;{pro nasledujici funkce:}

function lshiftpressed:boolean;
Begin lshiftpressed:=(sb and 2)=2 End;

function pshiftpressed:boolean;
Begin pshiftpressed:=(sb and 1)=1 End;

function shiftpressed:boolean;
Begin shiftpressed:=((sb and 2)=2)or((sb and 1)=1) End;

function lctrlpressed:boolean;
Begin lctrlpressed:=(sb and (256 or 4))=260 End;

function pctrlpressed:boolean;
Begin pctrlpressed:=(sb and (4 or 256))=4 End;

function ctrlpressed:boolean;
Begin ctrlpressed:=(sb and 4)=4 End;

function laltpressed:boolean;
Begin laltpressed:=(sb and (512 or 8))=520 End;

function paltpressed:boolean;
Begin paltpressed:=(sb and (8 or 512))=8 End;

function altpressed:boolean;
Begin altpressed:=(sb and 8)=8 End;

function capslockpressed:boolean;
Begin capslockpressed:=(sb and 16384)=16384 End;

function numlockpressed:boolean;
Begin numlockpressed:=(sb and 8192)=8192 End;

function scrolllockpressed:boolean;
Begin scrolllockpressed:=(sb and 4096)=4096 End;

function capslock:boolean;
Begin capslock:=(sb and 64)=64 End;

function numlock:boolean;
Begin numlock:=(sb and 32)=32 End;

function scrolllock:boolean;
Begin scrolllock:=(sb and 16)=16 End;

procedure setcapslock(jak:boolean);
Begin
if jak then sb:=sb or 64
       else sb:=sb and 65471; {65471=$FFFF and not 64}
End;{setcapslock}

procedure setnumlock(jak:boolean);
Begin
if jak then sb:=sb or 32
       else sb:=sb and 65503;
End;{setnumlock}

procedure setscrolllock(jak:boolean);
Begin
if jak then sb:=sb or 16
       else sb:=sb and 65519;
End;{setscrolllock}

procedure tokeybuf(s:string);
var i,b:byte;
Begin
for i:=1 to byte(s[0]) do begin {byte(s[0]) = length(s)}
                          b:=ord(s[i]);
                          asm
                          mov ax,5
                          mov cl,b
                          int 16h
                          end;
                          end;
End;{tokeybuf}

procedure MojeInt9; interrupt;
{Pro obsluhu klavesnice, kdyz je potreba cist vic stisknutych klaves najednou.
Vola se automaticky po kazdem stisku nebo pusteni nejake klavesy.}
var b:byte;
Begin
b:=port[$60];{nacteni stavu klavesnice}
if b<$80 then pressed[b]:=true{neco bylo zmacknuto}
         else pressed[b-$80]:=false;{neco bylo pusteno}
{na puvodni preruseni kaslu, snad na nem neco neni zivotne zavisle}
port[$20]:=$20;{oznami konec preruseni}
End;{mojeint9}

procedure InitKlav;
Begin
if not instalovano then
 begin
 getintvec(9,puvodniint9);{zaloha puvodniho preruseni}
 setintvec(9,@mojeint9);{nastaveni noveho preruseni}
 fillchar(pressed,128,false);{reset (vsechny klavesy nastav na "pusteno")}
 instalovano:=true;
 end;
End;{InitKlav}

procedure VratKlav;
Begin
if instalovano then
 begin
 setintvec(9,puvodniint9);{nastaveni puvodniho preruseni}
 fillchar(pressed,128,false);{jeste reset - pro jistotu}
 instalovano:=false;
 end;
End;{vratklav}

function KlavesyInstalovany:boolean;
Begin
klavesyinstalovany:=instalovano;
End;{KlavesyInstalovany}

procedure RychlostKlavesnice(zpozdeni,rychlost:byte); assembler;
Asm
mov AX,0305h
mov BH,zpozdeni
mov BL,rychlost
int 16h
End;{rychlostklavesnice}

END.